;												
; RDS-SIGNALGENERATOR fr ATmega8				
; Bernhard.Erfurt@gmx.de						
; 04/2014										
;												

;												
; Anschlussbelegung PINS						
;												
; PB0 ==> OUT RDS-Analog						
; PB1 ==> OUT 19kHz-Generator (Pilotton)		
; PB2 ==> 										
; PB3 ==> OUT 57kHz-GENERATOR 					
; PB4 ==> 										
; PB5 ==> 										
; PB6 ==> Quarz									
; PB7 ==> Quarz									
;												
; PC0 ==> OUT RDS-TAKT							
; PC1 ==> OUT RDS-DATA							
; PC2 ==> 										
; PC3 ==> 										
; PC4 ==> LED GELB								
; PC5 ==> LED GRN								
;												
; PD0 ==> 										
; PD1 ==> 										
; PD2 ==> INPUT 57kHz (vom Generator)			
; PD3 ==> 										
; PD4 ==> 										
; PD5 ==> 										
; PD6 ==> 										
; PD7 ==> 										
;												


; ATmega8 										
.include "m8def.inc"

; KONSTANTEN									
.equ TAKT							=16000000	
; TIMER-WERTE										
.equ TIMERWERT0 					=256-144	; 142 berwachungstimer ;(2 hoch 8  minus...)	
.equ TIMERCTC1						=419		; 19kHz	
.equ TIMERCTC2 						=139		; 57kHz	

; LED-GRUEN										
.equ LED_GRUEN_PIN_NR				= 5
.equ LED_GRUEN_DDR					= DDRC
.equ LED_GRUEN_PORT					= PORTC
; LED-GELB										
.equ LED_GELB_PIN_NR				= 4
.equ LED_GELB_DDR					= DDRC
.equ LED_GELB_PORT					= PORTC
; LED-ROT										
.equ LED_ROT_PIN_NR					= 3
.equ LED_ROT_DDR					= DDRC
.equ LED_ROT_PORT					= PORTC
; AUSGANG-19kHz (CTC-Timer1)					
.equ AUSGANG_19kHz_PIN_NR			= 1
.equ AUSGANG_19kHz_DDR				= DDRB
.equ AUSGANG_19kHz_PORT				= PORTB
; AUSGANG-57kHz (CTC-Timer2)					
.equ AUSGANG_57kHz_PIN_NR			= 3
.equ AUSGANG_57kHz_PIN				= PINB
.equ AUSGANG_57kHz_DDR				= DDRB
.equ AUSGANG_57kHz_PORT				= PORTB
; AUSGANG-RDS-57kHz-analog						
.equ AUSGANG_RDS_ANALOG_PIN_NR		= 0
.equ AUSGANG_RDS_ANALOG_DDR			= DDRB
.equ AUSGANG_RDS_ANALOG_PORT		= PORTB
; AUSGANG-RDS-TAKT								
.equ AUSGANG_RDS_TAKT_PIN_NR		= 0
.equ AUSGANG_RDS_TAKT_DDR			= DDRC
.equ AUSGANG_RDS_TAKT_PORT			= PORTC
; AUSGANG-RDS-DATA								
.equ AUSGANG_RDS_DATA_PIN_NR		= 1
.equ AUSGANG_RDS_DATA_DDR			= DDRC
.equ AUSGANG_RDS_DATA_PORT			= PORTC

; SRAM-BELEGUNG ATmega8							
.equ adr_DATEN						= SRAM_START		; 0x0060 START Adresse 		

.equ adr_RDS_DATA_BUFFER13			= SRAM_START+900

.equ adr_SRAM_CHECK					= SRAM_START+943	; SRAM CHECK muss immer "S" sein	

; REGISTER										

.def TIMER0WERT			= R2
.def RDS_ZAEHLER		= R4
.def RDS_ZAEHLER_BITS	= R5
.def DATA				= R11
.def INVERTIERUNG		= R10

.def NULL 		= R14
.def EINS 		= R15

.def temp 	= R16
.def temp1 	= R17
.def temp2 	= R18
.def temp3 	= R19
.def temp4 	= R20
.def temp5 	= R21
.def temp6 	= R22
.def temp7 	= R23
.def temp8 	= R24
.def temp9 	= R25


.cseg					;Beginn eines Code-Segmentes
.org 0					;Startadresse=0

rjmp RESET      		; Reset Handler                           				
rjmp RDS_GENERATOR 		; IRQ0 Handler                      					
rjmp INTERRUPT_ERROR	;rjmp EXT_INT1   ; IRQ1 Handler                      	
rjmp INTERRUPT_ERROR	;rjmp TIM2_COMP  ; Timer2 Compare Handler            	
rjmp INTERRUPT_ERROR	;rjmp TIM2_OVF   ; Timer2 Overflow Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_CAPT  ; Timer1 Capture Handler            	
rjmp INTERRUPT_ERROR	;rjmp TIM1_COMPA ; Timer1 CompareA Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_COMPB ; Timer1 CompareB Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_OVF   	  	; Timer1 Overflow Handler       
rjmp TIM0_OVF   		; Timer0 Overflow Handler           					
rjmp INTERRUPT_ERROR	;rjmp SPI_STC    ; SPI Transfer Complete Handler     	
rjmp INTERRUPT_ERROR	;rjmp ZEICHEN_EINLESEN 	; USART RX Complete Handler     
rjmp INTERRUPT_ERROR	;rjmp USART_UDRE ; UDR Empty Handler                 	
rjmp INTERRUPT_ERROR	;rjmp USART_TXC  ; USART TX Complete Handler         	
rjmp INTERRUPT_ERROR	;rjmp ADC        ; ADC Conversion Complete Handler   	
rjmp INTERRUPT_ERROR	;rjmp EE_RDY     ; EEPROM Ready Handler              	
rjmp INTERRUPT_ERROR	;rjmp ANA_COMP   ; Analog Comparator Handler         	
rjmp INTERRUPT_ERROR	;rjmp TWSI       ; Two-wire Serial Interface Handler 	
rjmp INTERRUPT_ERROR	;rjmp SPM_RDY    ; Store Program Memory Ready Handler	


; Unkorrekten Interrupt Aufruf 						
INTERRUPT_ERROR:
	cbi (LED_GRUEN_PORT),LED_GRUEN_PIN_NR		; GRN an	
	cbi (LED_GELB_PORT),LED_GELB_PIN_NR			; GELB an	
	cbi (LED_ROT_PORT),LED_ROT_PIN_NR			; ROT  an	
	rcall wait_100ms
	sbi (LED_GRUEN_PORT),LED_GRUEN_PIN_NR		; GRN aus	
	sbi (LED_GELB_PORT),LED_GELB_PIN_NR			; GELB aus  
	sbi (LED_ROT_PORT),LED_ROT_PIN_NR			; ROT  aus	
	rcall wait_100ms
	rjmp INTERRUPT_ERROR

RESET:                        
; STACK initialisieren								
	ldi temp, LOW(RAMEND)
    out SPL, temp
    ldi temp, HIGH(RAMEND)
    out SPH, temp
; SRAM lschen										
	rcall SRAM_CLEAR
; STARTWERTE										
	; NULL				
	clr NULL
	; EINS				
	ldi temp,1
	mov EINS,temp
	; TIMER0 Startwert	
	ldi temp,(TIMERWERT0)
	mov TIMER0WERT,temp
	; RDS				
	clr INVERTIERUNG
	clr RDS_ZAEHLER_BITS
	; SRAM CHECK		
	ldi temp,'S'
	STS(adr_SRAM_CHECK),temp
; PORT B+C+C initialisieren								
	out DDRB, NULL
	out DDRC, NULL
	out DDRD, NULL
	out PORTB,NULL
	out PORTC,NULL
	out PORTD,NULL
; PORT LED											
	; auf AUSGANG									
	sbi (LED_GRUEN_DDR),(LED_GRUEN_PIN_NR)		; GRN	
	sbi (LED_GELB_DDR),(LED_GELB_PIN_NR)		; GELB	
	sbi (LED_ROT_DDR),(LED_ROT_PIN_NR)			; ROT	
	; LEDs an									
	cbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)		; GRN an	
	cbi (LED_GELB_PORT) ,(LED_GELB_PIN_NR)		; GELB an	
	cbi (LED_ROT_PORT)  ,(LED_ROT_PIN_NR)		; ROT  an	
; AUSGANG-A										
	sbi (AUSGANG_19kHz_DDR),(AUSGANG_19kHz_PIN_NR)				; 19kHz-Generator
	sbi (AUSGANG_57kHz_DDR),(AUSGANG_57kHz_PIN_NR)				; 57kHz-Generator

	sbi (AUSGANG_RDS_ANALOG_DDR),(AUSGANG_RDS_ANALOG_PIN_NR)	; RDS-Analog	
	sbi (AUSGANG_RDS_TAKT_DDR),(AUSGANG_RDS_TAKT_PIN_NR)		; RDS-TAKT		
	sbi (AUSGANG_RDS_DATA_DDR),(AUSGANG_RDS_DATA_PIN_NR)		; RDS-DATA		
; AUSGNGE auf LOW								
	cbi (AUSGANG_19kHz_PORT)  ,(AUSGANG_19kHz_PIN_NR)			; 19kHz-Generator
	cbi (AUSGANG_57kHz_PORT)  ,(AUSGANG_57kHz_PIN_NR)			; 57kHz-Generator

	cbi (AUSGANG_RDS_ANALOG_PORT),(AUSGANG_RDS_ANALOG_PIN_NR)	; Analog 57kHz	
	cbi (AUSGANG_RDS_TAKT_PORT)  ,(AUSGANG_RDS_TAKT_PIN_NR)		; RDS-TAKT		
	cbi (AUSGANG_RDS_DATA_PORT)  ,(AUSGANG_RDS_DATA_PIN_NR)		; RDS-DATA		
; WDR_INITIALISIERUNG								
	rcall WDR_INITIALISIERUNG
; NEUSTART_MIT_WDR									
	rcall NEUSTART_MIT_WDR
; LED-TEST											
	rcall LED_TEST
; 	PROGRAMM_CHECK									
	rcall PROGRAMM_CHECK
; EXTERNER-INTERUPT									
	rcall EXTERNER_INTERUPT_INITIALISIEREN
	rcall EXTERNER_INTERRUPT_AKTIVIEREN
; CTC-TIMER1+2										
	rcall TIMER1_CTC_INITIALISIERUNG
	rcall TIMER2_CTC_INITIALISIERUNG
	rcall TIMER_CTC_SYNCHRONISATION
	rcall TIMER0_INITIALISIERUNG
	rcall TIMER_AKTIVIEREN
; Interrupts freigeben								
	sei
; ##############################################################################
; ##############################################################################
; ##############################################################################
LOOP:
	rcall RDS_TESTDATEN
	
	;ldi temp1,255
	;rcall RDS_TESTDATEN_TEMP1
rjmp LOOP
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Input temp1																	
RDS_TESTDATEN_TEMP1:
	WDR										; Watch-Dog-RESET	
	tst RDS_ZAEHLER_BITS
	brne RDS_TESTDATEN_TEMP1
;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
	cbi (LED_GRUEN_PORT),LED_GRUEN_PIN_NR		; GRN an	
	; Y-Initalisieren	
	ldi YL,LOW (adr_RDS_DATA_BUFFER13)
	ldi YH,HIGH(adr_RDS_DATA_BUFFER13)
	ldi temp9,13
RDS_TESTDATEN_TEMP1_s:
	ST Y+,temp1				; im SRAM ablegen							
	dec temp9
	brne RDS_TESTDATEN_TEMP1_s
	; Zwangspause	!
	rcall wait_1ms
	sbi (LED_GRUEN_PORT),LED_GRUEN_PIN_NR		; GRN aus	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
RDS_TESTDATEN:
	; Z-Initalisieren	
	ldi ZL,LOW (DATA_00*2)
	ldi ZH,HIGH(DATA_00*2)
	rcall RDS_DATA_TABELLE_Z
	; Z-Initalisieren	
	ldi ZL,LOW (DATA_01*2)
	ldi ZH,HIGH(DATA_01*2)
	rcall RDS_DATA_TABELLE_Z
	; Z-Initalisieren	
	ldi ZL,LOW (DATA_02*2)
	ldi ZH,HIGH(DATA_02*2)
	rcall RDS_DATA_TABELLE_Z
	; Z-Initalisieren	
	ldi ZL,LOW (DATA_03*2)
	ldi ZH,HIGH(DATA_03*2)
	rcall RDS_DATA_TABELLE_Z
	; Z-Initalisieren	
	ldi ZL,LOW (DATA_04*2)
	ldi ZH,HIGH(DATA_04*2)
	rcall RDS_DATA_TABELLE_Z
	; Z-Initalisieren	
	ldi ZL,LOW (DATA_05*2)
	ldi ZH,HIGH(DATA_05*2)
	rcall RDS_DATA_TABELLE_Z
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; 13 Daten-Bytes 4x(16+10) in den Puffer schieben								
RDS_DATA_TABELLE_Z:
	WDR										; Watch-Dog-RESET	
	tst RDS_ZAEHLER_BITS
	brne RDS_DATA_TABELLE_Z
;-------------------------------------------------------------------------------
	cbi (LED_GRUEN_PORT),LED_GRUEN_PIN_NR		; GRN an	
	; Y-Initalisieren	
	ldi YL,LOW (adr_RDS_DATA_BUFFER13)
	ldi YH,HIGH(adr_RDS_DATA_BUFFER13)
	ldi temp9,13
RDS_DATA_TABELLE_Z_s:
	LPM temp, Z+   			; aus Tabelle laden und Zeiger um 1 erhhen
	ST Y+,temp				; im SRAM ablegen							
	dec temp9
	brne RDS_DATA_TABELLE_Z_s
	; Zwangspause	!
	rcall wait_1ms
	sbi (LED_GRUEN_PORT),LED_GRUEN_PIN_NR		; GRN aus	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
.include "RDS_SIGNAL_TIMER.asm"
.include "RDS_SIGNAL_EXTINTERRUPT.asm"
.include "RDS_SIGNAL_SONSTIGES.asm"			; sonstiges						
.include "RDS_SIGNAL_WAIT_16MHZ.asm"		; 16 MHz						



DATA_00:	; ZEIT
.db 0xD4,0xF1,0xA3,0xD1,0x00,0x5B,0x6B,0xB9,0x17,0xB9,0x42,0x13,0x6B
DATA_01:
.db 0xD4,0xF1,0xA3,0xC1,0x02,0x1E,0xBF,0x15,0x60,0x9D,0x35,0x10,0xCC
DATA_02:
.db 0xD4,0xF1,0xA3,0xC1,0x02,0x1E,0xBF,0x15,0x60,0x9D,0x35,0x10,0xCC
DATA_03:
.db 0xD4,0xF1,0xA3,0xC1,0x02,0x45,0x20,0x85,0x66,0x59,0x48,0x83,0x27
DATA_04:
.db 0xD4,0xF1,0xA3,0xC1,0x02,0xA9,0x95,0x63,0x21,0x19,0x51,0x20,0x1C
DATA_05:
.db 0xD4,0xF1,0xA3,0xC1,0x03,0xC7,0xD5,0x64,0x52,0x7D,0x55,0x15,0x27

